#include "uPDF.h"
#include <iostream>
#include <sstream>
#include <string>  
using namespace std;
using namespace uPDF;

// Root includes
#include "TH1.h"
#include "TH2.h"
#include "TFile.h" 
#include "TCanvas.h"
#include <TApplication.h>
#include <TStyle.h>
#include <TROOT.h>
#include "TString.h"
//#include <unistd.h> 
#include "TLegend.h"

string filename ;
bool first;

int main(int argc,char **argv) {

TApplication* gMyRootApp = new TApplication("My ROOT Application", &argc, argv);

double kt,p ;

int kf;
double xmin=1e-5, xmax=1. ;
// set constants 
   kf = 2212 ; /* proton id */
   kt = 2. ;  /* tranverse momentum k_t */
   p = 100. ;   /* evolution scale p */
//   filename = "updf-grid.dat";
//   filename = "updf-new.dat";
//   string file_new = "updf-grid-sea.dat";
//   string file_new = "updf-set1-gluon-only.dat";
//   string file_new = "updf-grid.dat";
//   string file_new = "updf-new.dat";
   string file_new = "ccfm-gluon+sea-test.dat";
//   string file_new = "ccfm-gluon-test.dat";
//   string file_new = "ccfm-gluon+sea-noqcdc.dat";
//   string file_new = "updf-set1-sea-as-gluon.dat";
//   string file_new = "updf-set1-gluon-only-wg=wxqq.dat";
//   string file_new = "updf-set1-gluon+sea-wg=wxgg.dat";";
//   string file_new = "updf-set1-gluon+sea-wg=wxgg-without-resetting-Kid.dat"; 
//   string file_new = "updf-set1-gluon+sea-test.dat";
//      string file_new = "updf-set1-gluon+sea-wxqg=qxgg.dat";
//     string file_new = "updf-set1-gluon+sea-wxqg=wzqg+suda.dat";
//     string file_new = "updf-set1-gluon+sea-onlylast-wxqg=wzqg+suda.dat";
//   string file_new = "updf-set1-sea-nosuda.dat";
//   string file_new = "updf-set1-gluon-only-wg=wxqq.dat";
    string file_ref="JH-2013-set1.dat";
//   string file_ref="ccfm-gluon-test-0.27.dat";
//   string file_ref = "ccfm-gluon+sea-test.dat";
  //   string file_ref="updf-grid-nosea.dat";
//   string file_ref="updf-grid.dat";
      cout << " ************************************************" << endl;
      cout << " *      reading and plotting updf: uPDFread     *" << endl;
      cout << " ************************************************" << endl;
      cout << " give evolutions scale p: " << endl;
      cin >> p ;
      cout << " give k_t : " << endl;
      cin >> kt ;
/*
      cout << " please enter file-name " << endl;
      cin >> filename ;
      cout << " give evolutions scale p: " << endl;
      cin >> p ;
      cout << " give k_t : " << endl;
      cin >> kt ;
      cout << " give x_min and x_max " << endl;
      cin >> xmin, xmax ;
*/      
      cout << " read unintegrated gluon density from " << filename
      << " at k_t = " << kt << " p = " << p << endl;
      cout << " read x_min = " << xmin << "  x_max = "  << xmax << endl;
      
int npoint=50 ;
double log_xmin=log10(xmin),log_xmax=log10(xmax) ;
// histogram declaration 
      TH1F *h_gluon1 = new TH1F("xgluon1","xgluon1",npoint, log_xmin, log_xmax);
      TH1F *h_uval1 = new TH1F("xuval1","xuval1",npoint, log_xmin, log_xmax);
      TH1F *h_dval1 = new TH1F("xdval1","xdval1",npoint, log_xmin, log_xmax);
      TH1F *h_sea1 = new TH1F("xsea1","xsea1",npoint, log_xmin, log_xmax);
      TH1F *h_gluon_ref1 = new TH1F("xgluon_ref1","xgluon1",npoint, log_xmin, log_xmax);
      TH1F *h_uval_ref1 = new TH1F("xuval_ref1","xuval1",npoint, log_xmin, log_xmax);
      TH1F *h_dval_ref1 = new TH1F("xdval_ref1","xdval1",npoint, log_xmin, log_xmax);
      TH1F *h_sea_ref1 = new TH1F("xsea_ref1","xsea1",npoint, log_xmin, log_xmax);
//

double deltax = (log_xmax-log_xmin)/npoint;  
double arr[13];
double* xpq = &arr[6];

double x , kt2;
first = true ;
for ( int iloop=0; iloop <=npoint; iloop++) {

    x = pow(10,(log_xmin + deltax * iloop)); 
    kt2 = kt*kt ;
    filename = file_new ;
    ccfmuPDF(kf,x,kt2,p, arr) ;
//    cout << " x " << x << " xpq = " << xpq[0] << " " <<  xpq[1] << " " << xpq[2] << endl;
    h_gluon1 -> Fill(log10(x)+deltax/100/npoint,xpq[0]) ;
    h_uval1  -> Fill(log10(x)+deltax/100/npoint,xpq[1]) ;
    h_dval1  -> Fill(log10(x)+deltax/100/npoint,xpq[2]) ;
    h_sea1   -> Fill(log10(x)+deltax/100/npoint,xpq[3]) ;

}
first = true ;
for ( int iloop=0; iloop <=npoint; iloop++) {
    x = pow(10,(log_xmin + deltax * iloop)); 
    kt2 = kt*kt ;
    filename = file_ref ;
    ccfmuPDF(kf,x,kt2,p, arr) ;
//    cout << " x " << x << " xpq = " << xpq[0] << " " <<  xpq[1] << " " << xpq[2] << endl;
    h_gluon_ref1 -> Fill(log10(x)+deltax/100/npoint,xpq[0]) ;
    h_uval_ref1  -> Fill(log10(x)+deltax/100/npoint,xpq[1]) ;
    h_dval_ref1  -> Fill(log10(x)+deltax/100/npoint,xpq[2]) ;
    h_sea_ref1   -> Fill(log10(x)+deltax/100/npoint,xpq[3]) ;
 
}    



//    write histogramm out to file
      TFile file("output.root","RECREATE");
//general root settings 
      gROOT->Reset();
      gROOT->SetStyle("Plain");
      gStyle->SetPadTickY(1); // ticks at right side
      gStyle->SetOptStat(0); // get rid of statistics box
      TCanvas *c = new TCanvas("ctest", "" ,0, 0, 500, 500);
// divide the canvas in 1 parts in x and 1 in y
double col[50];
col[1]=2;
col[2]=4;
col[3]=6;
col[4]=1;
col[5]=2;
col[6]=4;
double lsize = 0.04;
      h_gluon_ref1 -> SetLineColor(col[1]);
      h_gluon1 -> SetLineColor(col[2]);
      h_uval_ref1 -> SetLineColor(col[1]);
      h_uval1 -> SetLineColor(col[2]);
      h_dval_ref1 -> SetLineColor(col[1]);
      h_dval1 -> SetLineColor(col[2]);
      h_sea_ref1 -> SetLineColor(col[1]);
      h_sea1 -> SetLineColor(col[2]);

      c -> Divide(2,2);
      c -> cd(1);
      double ymin=1e-5;
      double ymax =5;
      double xminl=log10(xmin), xmaxl=log10(xmax);
      TH2F *frame1 = new TH2F("frame1","",100,xminl,xmaxl,10,ymin,ymax); 
      frame1->SetTitle(";x; xgluon");

      gPad->SetLogy();
      frame1->Draw();  
      h_gluon_ref1 -> Draw("same");
      h_gluon1 -> Draw("same");
//      h_gluon1 -> Write("");
      TLegend* mylegend = new TLegend(0.6,0.74,0.8,0.85);
      mylegend->SetFillColor(0); // white background
      mylegend->SetBorderSize(0); // get rid of the borders
      mylegend->SetTextSize(0.03);
      mylegend->AddEntry(h_gluon_ref1,"reference","l");      
      mylegend->AddEntry(h_gluon1,"new","l");      
      mylegend->Draw();
      
      
      c -> cd(2) ;
      gPad->SetLogy();
      double ymin1=0.00001, ymax1=10.1;
      TH2F *frame2 = new TH2F("frame2","",100,xminl,xmaxl,10,ymin1,ymax1); 
      frame2->SetTitle(";x; xuval");
      frame2->Draw();  
      h_uval_ref1 -> Draw("same");   
      h_uval1 -> Draw("same");
//      h_uval1 -> Write();
      c -> cd(3) ;
      gPad->SetLogy();
      TH2F *frame3 = new TH2F("frame3","",100,xminl,xmaxl,10,ymin1,ymax1); 
      frame3->SetTitle(";x; xdval");
      frame3->Draw();  
      h_dval_ref1 -> Draw("same");
      h_dval1 -> Draw("same");
//      h_dval1 -> Write();
      c -> cd(4) ;
      double ymin2=1e-8, ymax2 =5;
      TH2F *frame4 = new TH2F("frame4","",100,xminl,xmaxl,10,ymin2,ymax); 
      frame4->SetTitle(";x; xsea");
      gPad->SetLogy();
      frame4->Draw();  
      h_sea_ref1 -> Draw("same");
      h_sea1 -> Draw("same");
//      h_sea1 -> Write();
      
//      c-> Draw();
      c->WaitPrimitive();
      gMyRootApp->SetReturnFromRun(true);
      file.Close();


} 
